/*******************************************************************************
 *	BComplex.h	BEAM Array
 *	T.Barnaby,	BEAM Ltd,	2009-09-10
 *	Copyright (c) 2012 All Right Reserved, Beam Ltd, http://www.beam.ltd.uk
 *******************************************************************************
 *
 * For license see LICENSE.txt at the root of the beamlib source tree.
 */
#ifndef BComplex_H
#define BComplex_H	1

#include <BTypes.h>
#include <complex>
#include <algorithm>

/// This is a complex number using BFloat64 sized parameters. It is based on the Standard C++ library complex class and has all of the functionality of that class.
typedef std::complex<BFloat64>	BComplex;

/// This is a complex number using BFloat32 sized parameters. It is based on the Standard C++ library complex class and has all of the functionality of that class.
typedef std::complex<BFloat32>	BComplex32;

/// This is a complex number using BFloat64 sized parameters. It is based on the Standard C++ library complex class and has all of the functionality of that class.
typedef std::complex<BFloat64>	BComplex64;

#endif
