/*******************************************************************************
 *	BTable.h	Simple table of data with CSV output
 *	T.Barnaby,	BEAM Ltd,	2009-02-10
 *	Copyright (c) 2022 All Right Reserved, Beam Ltd, https://www.beam.ltd.uk
 *	For license see LICENSE.txt at the root of the beamlib source tree.
 *******************************************************************************
 */
#ifndef BTable_H
#define BTable_H

#include <BArray.h>
#include <BString.h>

/// A simple string based table structure
class BTable {
public:
				BTable();
				~BTable();
	
	void			clear();
	void			setTitle(BArray<BString> title);
	void			addRow(BArray<BString>  data);
	
	BString			getString();
	void			print(FILE* file = stdout);

private:
	void			calculateWidths();
	BString			lineString(BArray<BString> line, int comment = 0);
	
	BArray<BString> 	otitle;
	BList<BArray<BString> >	odata;
	BArray<int>		ocolumnWidths;
};

#endif
