/*******************************************************************************
 *	BWEditHtml.h	BWEditHtml
 *	T.Barnaby,	BEAM Ltd,	2021-01-26
 *	Copyright (c) 2022 All Right Reserved, Beam Ltd, https://www.beam.ltd.uk
 *	For license see LICENSE.txt at the root of the beamlib source tree.
 *******************************************************************************
 */
#ifndef BWEditHtml_H
#define BWEditHtml_H	1

#include <BWidgets.h>
#include <qtextedit.h>
#include <qtextbrowser.h>
#include <qtextdocument.h>
#include <qtextobject.h>
#include <qtexttable.h>
#include <qtoolbar.h>
#include <qaction.h>
#include <qtoolbutton.h>

class BWEditHtml : public BVBox {
        Q_OBJECT
public:
			BWEditHtml(QWidget* parent);

	void		setReadOnly(Bool on);

	void		setHtml(QString html);

	Bool		isModified();
	QString		getHtml();
	QString		getHtmlFull();

signals:

private slots:
	void		changePara(const QString& para);
	void		toggleBold();
	void		toggleItalic();
	void		toggleUnderline();
	void		toggleNumList();
	void		toggleBullList();
	void		addLink();

	void		test();
	void		test1();
	//void		cut();

	void		formatChanged(const QTextCharFormat& format);
	void		cursorPositionChanged();

private:
	void		emitFrame(const QTextFrame& frame);
	void		emitBlock(const QTextBlock& block);
	void		emitTextLength(const char* attribute, const QTextLength& length);
	void		emitFragment(const QTextFragment& fragment);
	Bool		emitCharFormatStyle(const QTextCharFormat& format);
	void		emitAttribute(const char* attribute, const QString& value);
	//void		emitFloatStyle(QTextFrameFormat::Position pos, StyleMode mode);

	QAction*	actionNew(QString name, QString icon, QObject* obj, const char* slot, QString shortCut = "", QString tip = "", bool toggle = 0);
	void		mergeFormatOnWordOrSelection(const QTextCharFormat& format);

	QToolBar*	owToolbar;
	QTextBrowser*	owEditor;
	QString		ohtml;

	QComboBox*	owParaType;
	QAction*	owActionBold;
	QAction*	owActionItalic;
	QAction*	owActionUnderline;
	QAction*	owActionNumList;
	QAction*	owActionBullList;
	QAction*	owActionLink;
	
	// Content
	QString			ocontent;
	
	// Html export
	QTextBlockFormat	oblockFormat;
};
#endif
